// Copyright 2007 Michael Green
// mike@mikegreen.name
//

myversion=1.0;

main
{
	sw=recall("MGRandomSelect_1",1);
	select_per = recall("MGRandomSelect_2",50);

	reqbegin("MG Random Select MD");
	c1 = ctlchoice("Select     ",1,@"Point", " Polygon"@);
	c2 = ctlinteger("Percent (%)    ",select_per);
	if (!reqpost()) return;

	sw = getvalue(c1);
	select_per = getvalue(c2);

	reqend();

	store("MGRandomSelect_1",sw);
	store("MGRandomSelect_2",select_per);

	selmode(USER);

	editbegin();
	if(sw==1)
		list=points;
	else
		list=polygons;
	editend();

	sel=RandomSelect(list,select_per);

	if(sw==1)
		selpoint( SET, POINTID, sel);
	else
		selpolygon( SET, POLYID, sel);
}

RandomSelect:list,select_per
{
 	listsize=list.size();

	moninit((listsize/(100/select_per)),"Selecting...");
	for(i=1;i<=(listsize/(100/select_per));i++)
	{
		if(monstep()) return;
		val = random(1,listsize);
		sel[i] = list[ val ];
	}
	monend();

	sel.sortA();
	sel.reduce();
	sel.pack();
	sel.trunc();

	return(sel);
}

